// Generated by CoffeeScript 1.3.3
(function() {
  var ObjectId, async, mongojs, mongoose, _,
    __slice = [].slice;

  async = require('async');

  _ = require('underscore');

  mongoose = require('mongoose');

  mongojs = require('mongojs');

  ObjectId = mongoose.Schema.ObjectId;

  _.mixin(require('underscore.plus'));

  exports.create = function() {
    var api, db, internalListSub, massage, massageCore, massageOne, massaged, meta, model, models, nullablesValidation, preRemoveCascadeNonNullable, preRemoveCascadeNullable, preprocFilter, propagate, specTransform;
    db = null;
    api = {};
    models = {};
    meta = {};
    api.ObjectId = ObjectId;
    propagate = function(callback, f) {
      return function() {
        var args, err;
        err = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
        if (err) {
          return callback(err);
        } else {
          return f.apply(this, args);
        }
      };
    };
    model = function(name, schema) {
      var ss;
      ss = new mongoose.Schema(schema, {
        strict: true
      });
      return mongoose.model(name, ss);
    };
    api.isValidId = function(id) {
      try {
        mongoose.mongo.ObjectID(id);
        return true;
      } catch (ex) {
        return false;
      }
    };
    preprocFilter = function(filter) {
      var x;
      x = _.extend({}, filter);
      if (x.id) {
        x._id = x.id;
      }
      delete x.id;
      return x;
    };
    massageOne = function(x) {
      if (!(x != null)) {
        return x;
      }
      x.id = x._id;
      delete x._id;
      return x;
    };
    massageCore = function(r2) {
      if (Array.isArray(r2)) {
        return r2.map(massageOne);
      } else {
        return massageOne(r2);
      }
    };
    massage = function(r2) {
      return massageCore(JSON.parse(JSON.stringify(r2)));
    };
    massaged = function(f) {
      return function(err, data) {
        if (err) {
          return f(err);
        } else {
          return f(null, massage(data));
        }
      };
    };
    api.connect = function(databaseUrl, callback) {
      mongoose.connect(databaseUrl);
      db = mongojs.connect(databaseUrl, api.getModels());
      return db[Object.keys(models)[0]].find(function(err) {
        return callback(err);
      });
    };
    api.list = function(model, filter, callback) {
      var rr;
      if (!(callback != null)) {
        callback = filter;
        filter = {};
      }
      filter = preprocFilter(filter);
      rr = models[model].find(filter);
      if (meta[model].defaultSort != null) {
        rr = rr.sort(meta[model].defaultSort, 1);
      }
      return rr.exec(massaged(callback));
    };
    api.getOne = function(model, filter, callback) {
      if (!(callback != null)) {
        callback = filter;
        filter = {};
      }
      filter = preprocFilter(filter);
      return models[model].findOne(filter, function(err, data) {
        if (err) {
          if (err.toString() === 'Error: Invalid ObjectId') {
            callback("No such id");
          } else {
            callback(err);
          }
          return;
        }
        return callback((!(data != null) ? "No such id" : void 0), massage(data));
      });
    };
    api.delOne = function(model, filter, callback) {
      if (!(callback != null)) {
        callback = filter;
        filter = {};
      }
      filter = preprocFilter(filter);
      return models[model].findOne(filter, propagate(callback, function(d) {
        if (!(d != null)) {
          return callback("No such id");
        } else {
          return d.remove(function(err) {
            return callback(err, !err ? massage(d) : void 0);
          });
        }
      }));
    };
    api.putOne = function(modelName, data, filter, callback) {
      var inputFields, invalidFields, validField;
      if (!(callback != null)) {
        callback = filter;
        filter = {};
      }
      filter = preprocFilter(filter);
      model = models[modelName];
      inputFields = Object.keys(data);
      validField = Object.keys(model.schema.paths);
      invalidFields = _.difference(inputFields, validField);
      if (invalidFields.length > 0) {
        callback("Invalid fields: " + invalidFields.join(', '));
        return;
      }
      return model.findOne(filter, propagate(callback, function(d) {
        if (!(d != null)) {
          callback("No such id");
          return;
        }
        inputFields.forEach(function(key) {
          return d[key] = data[key];
        });
        return d.save(function(err) {
          return callback(err, err ? null : massage(d));
        });
      }));
    };
    api.post = function(model, indata, callback) {
      var owners, ownersOwners, ownersRaw, saveFunc;
      saveFunc = function(data) {
        return new models[model](data).save(function(err) {
          var fieldMatch, valueMatch;
          if (err && err.code === 11000) {
            fieldMatch = err.err.match(/\$([a-zA-Z]+)_1/);
            valueMatch = err.err.match(/"([a-zA-Z]+)"/);
            if (fieldMatch && valueMatch) {
              return callback("Duplicate value '" + valueMatch[1] + "' for " + fieldMatch[1]);
            } else {
              return callback("Unique constraint violated");
            }
          } else {
            return massaged(callback).apply(this, arguments);
          }
        });
      };
      ownersRaw = api.getOwners(model);
      owners = _(ownersRaw).pluck('plur');
      ownersOwners = _(owners.map(function(x) {
        return api.getOwners(x);
      })).flatten();
      if (ownersOwners.length === 0) {
        return saveFunc(indata);
      } else {
        return api.getOne(owners[0], {
          id: indata[ownersRaw[0].sing]
        }, function(err, ownerdata) {
          var metaFields, paths;
          paths = models[owners[0]].schema.paths;
          metaFields = Object.keys(paths).filter(function(key) {
            return !!paths[key].options['x-owner'] || !!paths[key].options['x-indirect-owner'];
          });
          metaFields.forEach(function(key) {
            return indata[key] = ownerdata[key];
          });
          return saveFunc(indata);
        });
      }
    };
    internalListSub = function(model, outer, id, filter, callback) {
      var finalFilter;
      if (!(callback != null)) {
        callback = filter;
        filter = {};
      }
      if ((filter[outer] != null) && filter[outer].toString() !== id.toString()) {
        callback('No such id');
        return;
      }
      filter = preprocFilter(filter);
      finalFilter = _.extend({}, filter, _.makeObject(outer, id));
      return models[model].find(finalFilter, callback);
    };
    api.delMany = function(primaryModel, primaryId, propertyName, secondaryModel, secondaryId, callback) {
      return models[primaryModel].findById(primaryId, propagate(callback, function(data) {
        var conditions, options, update;
        conditions = {
          _id: primaryId
        };
        update = {
          $pull: _.makeObject(propertyName, secondaryId)
        };
        options = {};
        return models[primaryModel].update(conditions, update, options, function(err, numAffected) {
          return callback(err);
        });
      }));
    };
    api.postMany = function(primaryModel, primaryId, propertyName, secondaryModel, secondaryId, callback) {
      return models[primaryModel].findById(primaryId, propagate(callback, function(data) {
        return models[secondaryModel].findById(secondaryId, propagate(callback, function() {
          if (-1 === data[propertyName].indexOf(secondaryId)) {
            data[propertyName].push(secondaryId);
          }
          return data.save(function(err) {
            return callback(err, {});
          });
        }));
      }));
    };
    api.getMany = function(primaryModel, primaryId, propertyName, callback) {
      return models[primaryModel].findOne({
        _id: primaryId
      }).populate(propertyName).run(function(err, story) {
        return callback(err, massage(story[propertyName]));
      });
    };
    api.getManyBackwards = function(model, id, propertyName, callback) {
      return db[model].find(_.makeObject(propertyName, new db.bson.ObjectID(id.toString())), function(err, result) {
        return callback(err, massage(result));
      });
    };
    specTransform = function(tgt, src, keys) {
      return keys.forEach(function(key) {
        if (!(src[key].type != null)) {
          throw "must assign a type: " + JSON.stringify(keys);
        } else if (src[key].type === 'nested') {
          tgt[key] = {};
          return specTransform(tgt[key], src[key], _.without(Object.keys(src[key]), 'type'));
        } else if (src[key].type === 'string') {
          tgt[key] = {
            type: String,
            required: !!src[key].required
          };
          if (src[key]["default"] != null) {
            tgt[key]["default"] = src[key]["default"];
          }
          if (src[key].index != null) {
            tgt[key].index = src[key].index;
          }
          if (src[key].unique != null) {
            tgt[key].unique = src[key].unique;
          }
          if (src[key].validate != null) {
            return tgt[key].validate = function(value, callback) {
              return src[key].validate(api, value, callback);
            };
          }
        } else if (src[key].type === 'number') {
          tgt[key] = {
            type: Number,
            required: !!src[key].required
          };
          if (src[key]["default"] != null) {
            tgt[key]["default"] = src[key]["default"];
          }
          if (src[key].index != null) {
            tgt[key].index = src[key].index;
          }
          if (src[key].unique != null) {
            return tgt[key].unique = src[key].unique;
          }
        } else if (src[key].type === 'date') {
          tgt[key] = {
            type: Date,
            required: !!src[key].required
          };
          if (src[key]["default"] != null) {
            tgt[key]["default"] = src[key]["default"];
          }
          if (src[key].index != null) {
            tgt[key].index = src[key].index;
          }
          if (src[key].unique != null) {
            return tgt[key].unique = src[key].unique;
          }
        } else if (src[key].type === 'boolean') {
          tgt[key] = {
            type: Boolean,
            required: !!src[key].required
          };
          if (src[key]["default"] != null) {
            tgt[key]["default"] = src[key]["default"];
          }
          if (src[key].index != null) {
            tgt[key].index = src[key].index;
          }
          if (src[key].unique != null) {
            return tgt[key].unique = src[key].unique;
          }
        } else if (src[key].type === 'hasOne') {
          return tgt[key] = {
            ref: src[key].model,
            'x-validation': src[key].validation
          };
        } else if (src[key].type === 'hasMany') {
          return tgt[key] = [
            {
              type: ObjectId,
              ref: src[key].model
            }
          ];
        } else {
          throw "Invalid type: " + src[key].type;
        }
      });
    };
    api.defModel = function(name, conf) {
      var inspec, owners, spec;
      spec = {};
      owners = conf.owners || {};
      inspec = conf.fields || {};
      specTransform(spec, inspec, Object.keys(inspec));
      Object.keys(owners).forEach(function(ownerName) {
        return spec[ownerName] = {
          type: ObjectId,
          ref: owners[ownerName],
          required: true,
          'x-owner': true
        };
      });
      Object.keys(owners).forEach(function(ownerName) {
        var paths;
        paths = models[owners[ownerName]].schema.paths;
        return Object.keys(paths).filter(function(p) {
          return paths[p].options['x-owner'] || paths[p].options['x-indirect-owner'];
        }).forEach(function(p) {
          return spec[p] = {
            type: ObjectId,
            ref: paths[p].options.ref,
            required: true,
            'x-indirect-owner': true
          };
        });
      });
      Object.keys(spec).forEach(function(fieldName) {
        if (spec[fieldName].ref != null) {
          return spec[fieldName].type = ObjectId;
        }
      });
      meta[name] = {
        defaultSort: conf.defaultSort
      };
      models[name] = model(name, spec);
      models[name].schema.pre('save', nullablesValidation(models[name].schema));
      models[name].schema.pre('remove', function(next) {
        return preRemoveCascadeNonNullable(models[name], this._id.toString(), next);
      });
      return models[name].schema.pre('remove', function(next) {
        return preRemoveCascadeNullable(models[name], this._id.toString(), next);
      });
    };
    api.getMetaFields = function(modelName) {
      var metaFields, paths, typeFunc, typeMap;
      typeMap = {
        ObjectID: 'string',
        String: 'string',
        Number: 'number',
        Boolean: 'boolean',
        Date: 'date'
      };
      paths = models[modelName].schema.paths;
      typeFunc = function(x) {
        if (x === Boolean) {
          return 'boolean';
        }
        if (x === Date) {
          return 'date';
        }
      };
      metaFields = Object.keys(paths).map(function(key) {
        return {
          name: (key === '_id' ? 'id' : key),
          readonly: key === '_id' || !!paths[key].options['x-owner'] || !!paths[key].options['x-indirect-owner'],
          required: !!paths[key].options.required,
          type: typeMap[paths[key].instance] || typeFunc(paths[key].options.type) || 'unknown'
        };
      });
      return _.sortBy(metaFields, 'name');
    };
    api.getOwners = function(modelName) {
      var outers, paths;
      paths = models[modelName].schema.paths;
      outers = Object.keys(paths).filter(function(x) {
        return paths[x].options['x-owner'];
      }).map(function(x) {
        return {
          plur: paths[x].options.ref,
          sing: x
        };
      });
      return outers;
    };
    api.getOwnedModels = function(ownerModelName) {
      return _.flatten(Object.keys(models).map(function(modelName) {
        var paths;
        paths = models[modelName].schema.paths;
        return Object.keys(paths).filter(function(x) {
          return paths[x].options.type === ObjectId && paths[x].options.ref === ownerModelName && paths[x].options['x-owner'];
        }).map(function(x) {
          return {
            name: modelName,
            field: x
          };
        });
      }));
    };
    api.getManyToMany = function(modelName) {
      var manyToMany, paths;
      paths = models[modelName].schema.paths;
      manyToMany = Object.keys(paths).filter(function(x) {
        return Array.isArray(paths[x].options.type);
      }).map(function(x) {
        return {
          ref: paths[x].options.type[0].ref,
          name: x
        };
      });
      return manyToMany;
    };
    api.getModels = function() {
      return Object.keys(models);
    };
    nullablesValidation = function(schema) {
      return function(next) {
        var nonNullOuters, outers, paths, self;
        self = this;
        paths = schema.paths;
        outers = Object.keys(paths).filter(function(x) {
          return paths[x].options.type === ObjectId && typeof paths[x].options.ref === 'string' && !paths[x].options['x-owner'];
        }).map(function(x) {
          return {
            plur: paths[x].options.ref,
            sing: x,
            validation: paths[x].options['x-validation']
          };
        });
        nonNullOuters = outers.filter(function(x) {
          return self[x.sing] != null;
        });
        return async.forEach(nonNullOuters, function(o, callback) {
          return api.getOne(o.plur, {
            id: self[o.sing]
          }, function(err, data) {
            if (err || !data) {
              return callback(new Error("Invalid pointer"));
            } else if (o.validation) {
              return o.validation(self, data, function(err) {
                return callback(err ? new Error(err) : void 0);
              });
            } else {
              return callback();
            }
          });
        }, next);
      };
    };
    preRemoveCascadeNonNullable = function(owner, id, next) {
      var flattenedModels;
      flattenedModels = api.getOwnedModels(owner.modelName);
      return async.forEach(flattenedModels, function(mod, callback) {
        return internalListSub(mod.name, mod.field, id, function(err, data) {
          return async.forEach(data, function(item, callback) {
            return item.remove(callback);
          }, callback);
        });
      }, next);
    };
    preRemoveCascadeNullable = function(owner, id, next) {
      var flattenedModels, ownedModels;
      ownedModels = Object.keys(models).map(function(modelName) {
        var paths;
        paths = models[modelName].schema.paths;
        return Object.keys(paths).filter(function(x) {
          return paths[x].options.type === ObjectId && paths[x].options.ref === owner.modelName && !paths[x].options['x-owner'];
        }).map(function(x) {
          return {
            name: modelName,
            field: x
          };
        });
      });
      flattenedModels = _.flatten(ownedModels);
      return async.forEach(flattenedModels, function(mod, callback) {
        return internalListSub(mod.name, mod.field, id, function(err, data) {
          return async.forEach(data, function(item, callback) {
            item[mod.field] = null;
            item.save();
            return callback();
          }, callback);
        });
      }, next);
    };
    return api;
  };

}).call(this);
